//+------------------------------------------------------------------+
//|                                                    V_6.mq4 |
//|                      Copyright  2008, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, MetaQuotes Software Corp."
#property link      "http://www.MQL-Advisor.ru"

extern double Lot=0.01;
extern int    Dist=25;
extern double Pribyl=5;
extern double K_Martin=2;

int r,ret;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
Comment("");   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
int B=0,S=0,BS=0,SS=0;
double Prof=0,L_B=0,L_S=0,Lev_B,Lev_S,L_BS=0,L_SS=0;  
//--------------    --------------------------------------------      
          for( r=0;r<OrdersTotal();r++) //  
      {
      if(OrderSelect(r,SELECT_BY_POS,MODE_TRADES)==false)    continue;
      if(OrderSymbol()==Symbol())
      {
      if (OrderType()==OP_BUY )        {  B++;Prof=Prof+OrderProfit()+OrderSwap();L_B=L_B+OrderLots();Lev_B=OrderOpenPrice();}
      if (OrderType()==OP_SELL )       {  S++;Prof=Prof+OrderProfit()+OrderSwap();L_S=L_S+OrderLots();Lev_S=OrderOpenPrice();}

      if (OrderType()==OP_BUYSTOP )   {   BS++;Lev_B=OrderOpenPrice();L_BS=L_BS+OrderLots();}
      if (OrderType()==OP_SELLSTOP)   {   SS++;Lev_S=OrderOpenPrice();L_SS=L_SS+OrderLots();}
      }}
//---------  -----------------------------
Comment("  ",Prof,"   Dist  ",Dist,"\n"," BUY  ",Lev_B,"\n"," SELL  ",Lev_S,
        "\n","B  ",L_B,"  BS  ",L_BS,"\n","S  ",L_S,"  SS  ",L_SS);      
      
//-------    ------------------------
if (B+S+BS+SS==0)
{
ret= OrderSend(Symbol(),OP_BUYSTOP,Lot,Ask+Dist*Point,0,0,0,"",0,0,Blue);
ret= OrderSend(Symbol(),OP_SELLSTOP,Lot,Bid-Dist*Point,0,0,0,"",0,0,Red);
return(0);     
}

//---------     -------------------------
if (L_B>L_S && L_B>=L_S+L_SS) // --   BUY   SELL
{
ret=OrderSend(Symbol(),OP_SELLSTOP,NormalizeDouble(L_B*K_Martin-(L_S+L_SS),2),Lev_S,3,0,0,"",0,0,CLR_NONE);
return(0);
}
if (L_S>L_B && L_S>=L_B+L_BS) // --   SELL   BUY
{
ret=OrderSend(Symbol(),OP_BUYSTOP,NormalizeDouble(L_S*K_Martin-(L_B+L_BS),2),Lev_B,3,0,0,"",0,0,CLR_NONE);
return(0);
}
if (Prof>=Pribyl) CloseALL();
   return(0);
  }
//+------------------------------------------------------------------+
//----------------   -----------------------------------------
int Ord_Tot_Sym()
{
int O_T=0;
      for(int rr=0;rr<OrdersTotal();rr++) //  
      {
      if(OrderSelect(rr,SELECT_BY_POS,MODE_TRADES)==false)    continue;
      if(OrderSymbol()==Symbol())
      {
   O_T++;    
      }}
      if (O_T>0) return(1);
      else return(0);
}
    

//-------------- CloseAll --------------------------   
int CloseALL()
{
int ic;
 while (Ord_Tot_Sym()>0) 
 {
 RefreshRates();
                  for(ic=OrdersTotal()-1;ic>=0;ic--)
                   {
                  if(OrderSelect(ic,SELECT_BY_POS,MODE_TRADES)==false) continue;
                  if (OrderSymbol()==Symbol())
                  {
                  if (OrderType()==OP_BUY)
                  {
                  //RefreshRates();
                  ret=OrderClose(OrderTicket(),OrderLots(),Bid,0,CLR_NONE);
                  if (IsTradeAllowed()) continue;
                  else Sleep(1000);
                  }
                                    
                  if (OrderType()==OP_SELL)
                  {
                  //RefreshRates();
                  ret=OrderClose(OrderTicket(),OrderLots(),Ask,0,CLR_NONE);
                  if (IsTradeAllowed()) continue;
                  else Sleep(1000);
                  }}}
//---------        ------------------------                    
                  for(ic=OrdersTotal()-1;ic>=0;ic--)
                   {
                  if(OrderSelect(ic,SELECT_BY_POS,MODE_TRADES)==false) continue;
                  if (OrderSymbol()==Symbol())
                  {
                  if (OrderType()==OP_BUYSTOP || OrderType()==OP_SELLSTOP ||
                     OrderType()==OP_BUYLIMIT || OrderType()==OP_SELLLIMIT)
                  ret=OrderDelete(OrderTicket());
                  }}
      PlaySound("MsgBell.wav" );
      }
   return(0);
  }